﻿Public Class Form1
    #Region "変数."
        Dim Cls_Holiday As NSDHoliday = Nothing ' 休日取得関数.
    #End Region

    #Region "Sub Button1_Click : 春分の日を取得します."
        Private Sub Button1_Click( sender As System.Object,  e As System.EventArgs) Handles Button1.Click
            Try
                Do
                    Dim Int_Year As Integer         ' 年.
                    Dim Int_Day As Integer          ' 日.
                    Dim Str_Msg As String = Nothing ' メッセージ.

                    ' 年の確認.
                    If IsNumeric(Me.TextBox1.Text) Then
                        Int_Year = CInt(Me.TextBox1.Text)
                    Else
                        MsgBox("年を入力して下さい。")
                        Exit Do
                    End If

                    ' 春分の日.
                    If Cls_Holiday.GetSyunbunDay(Int_Year, Int_Day) Then
                        Str_Msg = "西暦" & CStr(Int_Year) & "年の春分は3/" & CStr(Int_Day) & "日です。"
                    Else
                        Str_Msg = "春分の日の取得に失敗しました。"
                    End If
                    MsgBox(Str_Msg)
                Loop While (0)
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Button2_Click : 秋分の日を取得します."
        Private Sub Button2_Click( sender As System.Object,  e As System.EventArgs) Handles Button2.Click
            Try
                Do
                    Dim Int_Year As Integer         ' 年.
                    Dim Int_Day As Integer          ' 日.
                    Dim Str_Msg As String = Nothing ' メッセージ.

                    ' 年の確認.
                    If IsNumeric(Me.TextBox1.Text) Then
                        Int_Year = CInt(Me.TextBox1.Text)
                    Else
                        MsgBox("年を入力して下さい。")
                        Exit Do
                    End If

                    ' 秋分の日.
                    If Cls_Holiday.GetSyuubunDay(Int_Year, Int_Day) Then
                        Str_Msg = "西暦" & CStr(Int_Year) & "年の秋分は9/" & CStr(Int_Day) & "日です。"
                    Else
                        Str_Msg = "秋分の日の取得に失敗しました。"
                    End If
                    MsgBox(Str_Msg)
                Loop While (0)

            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Button5_Click : プログラムを終了します."
        Private Sub Button5_Click( sender As System.Object,  e As System.EventArgs) Handles Button5.Click
            Try
                Me.Close()
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Button3_Click : 休日を確認します."
        Private Sub Button3_Click( sender As System.Object,  e As System.EventArgs) Handles Button3.Click
            Try
                Dim Str_YMD As String = Nothing     ' 年月日.
                Dim Bln_Holiday As Boolean = False  ' True:休日 False:休日でない.
                Dim Int_Kind As NSDHoliday.NSD_HOLIDAY_KIND ' 休日種類.
                Dim Int_DayKind As NSDHoliday.NSD_HOLIDAY_KIND          ' 休日曜日確認用.
                Dim Str_Name As String = Nothing    ' 名前.
                Dim Str_Msg As String = Nothing     ' メッセージ.
            
                Str_YMD = Me.TextBox2.Text
                ' 休日の確認します.
                If Cls_Holiday.IsHoliday(Str_YMD, Bln_Holiday, Int_Kind) Then
                    If Bln_Holiday Then
                        ' 休日.
                        Str_Msg = "西暦：" & Str_YMD & ControlChars.CrLf
                        ' 休日の名前を取得します.
                        If Cls_Holiday.GetHolidayName(Int_Kind, Str_Name, Int_DayKind) Then
                            If [String].IsNullOrEmpty(Str_Name) Then
                                ' 祝日とかさならない日曜日.
                                Str_Msg &= "日曜日"
                            Else
                                ' 祝日.
                                Str_Msg &= Str_Name
                            End If
                            Str_Msg &= "です。"
                        End If
                    Else
                        Str_Msg = "休日ではありません。"
                    End If
                Else
                    Str_Msg = "休日の確認に失敗しました。"
                End If
                ' メッセージを表示します.
                MsgBox(Str_Msg)

            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Button4_Click : 年間休日を確認します."
        Private Sub Button4_Click( sender As System.Object,  e As System.EventArgs) Handles Button4.Click
            Try
                Dim Str_Year As String = Nothing                                ' 年.
                Dim Int_Year As Integer                                         ' 年.
                Dim Bln_Flag As Boolean                                         ' 休日取得フラグ.
                Dim Cls_HolidayInfo() As NSDHoliday.NSD_HolidayInfo = Nothing   ' 休日情報.
                Dim Int_Loop As Integer                                         ' ループ変数.

                ' リストボックスをクリアする.
                Me.ListBox1.Items.Clear()

                ' 休日を求める年をセットします.
                Str_Year = Me.TextBox3.Text

                ' 日曜のみを含めるかをセットします.
                If Me.RadioButton1.Checked Then
                    ' 日曜のみは含めない.
                    Bln_Flag = False
                Else
                    ' 日曜のみも含める.
                    Bln_Flag = True
                End If

                If IsNumeric(Str_Year) Then
                    ' 年をセットする.
                    Int_Year = CInt(Str_Year)

                    ' 1年間の休日を取得します.
                    If Cls_Holiday.GetYearlyHoliday(Int_Year, Bln_Flag, Cls_HolidayInfo) Then
                        ' 1年間の休日をセットします.
                        For Int_Loop = 0 To Cls_HolidayInfo.Length - 1
                            With Cls_HolidayInfo(Int_Loop)
                                Me.ListBox1.Items.Add(Cls_Holiday.GetYMD(.Date_Day) & _
                                                      "(" & Cls_Holiday.GetWeekDayName(.Date_Day, Me.Cmb_WeekDayName.SelectedItem) & _
                                                      ")" & " " & .HolidayName)
                            End With
                        Next Int_Loop
                    End If
                End If

            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Form."
        #Region "Sub Form1_Load : Loadイベント."
            Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
                Try
                    If (Cls_Holiday Is Nothing) Then
                        Cls_Holiday = New NSDHoliday
                    End If

                    ' 曜日の表記スタイル設定.
                    With Me.Cmb_WeekDayName
                        .Items.Clear()

                        For Int_Loop As Integer = 0 To Cls_Holiday.WeekDayNameStyleList.Count - 1
                            .Items.Add(Cls_Holiday.WeekDayNameStyleList.Item(Int_Loop))
                        Next

                        .SelectedIndex = 0
                    End With
                Catch ex As Exception

                End Try
            End Sub
        #End Region

        #Region "Sub Form1_FormClosed : FormClosedイベント."
            Private Sub Form1_FormClosed(sender As Object, e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
                Try
                    ' 解放処理.
                    If Not (Cls_Holiday Is Nothing) Then
                        Cls_Holiday.Dispose()
                        Cls_Holiday = Nothing
                    End If

                Catch ex As Exception

                End Try
            End Sub
        #End Region
    #End Region
End Class
